/**
 *
 */
package de.intevation.gnv.transition;

import java.util.Map;

import org.apache.log4j.Logger;
import org.w3c.dom.Node;

import de.intevation.artifactdatabase.Config;
import de.intevation.gnv.state.InputData;
import de.intevation.gnv.state.State;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class PresettingsValueCompareTransition extends TransitionBase {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(PresettingsValueCompareTransition.class);
    
    private String dataName = null;
    private String dataValue = null;
    private String operator = null;
    
    /**
     * The UID of this Class.
     */
    private static final long serialVersionUID = -7846722158776823205L;

    /**
     * Constructor
     */
    public PresettingsValueCompareTransition() {
        super();
    }

    /**
     * @see de.intevation.gnv.transition.Transition#isValid(de.intevation.gnv.state.State)
     */
    public boolean isValid(State state) {
        Map<String, InputData> preSettings = state.getPreSettings();
        if (preSettings != null){
            boolean dataAvailable = preSettings.containsKey(dataName);
            if (dataAvailable){
                if (operator.equals("equal")){
                    return preSettings.get(dataName).getValue().startsWith(dataValue);
                }else if (operator.equals("notequal")){
                    return !preSettings.get(dataName).getValue().startsWith(dataValue);
                }
            }
        }
        if (operator.equals("notequal")){
            return true;
        }
        return false;
    }

    @Override
    public void setup(Node configuration) {
        super.setup(configuration);
        this.dataName = Config.getStringXPath(configuration,"condition/@inputvalue");
        this.dataValue = Config.getStringXPath(configuration,"condition/@value");
        this.operator = Config.getStringXPath(configuration,"condition/@operator");
    }
    

}
